class TileSet {
	// There are 56 tiles in a full tantrix set
	int numTiles;
	// Each tile is represented by a 6 character String
	int TileNames[];
	String TileDesc[];
	
	private Define define;   

	public TileSet(String tilesToUse) {
	
		int numCurrentTiles=0;

		numTiles = 0;
		int setNumber = define.ALL_TILES;
		System.out.println("Using tileset("+setNumber+")");

		if ((setNumber&define.NO_BLUE_TILES)>0) {
			numTiles+=14;
		}
		
		if ((setNumber&define.NO_RED_TILES)>0) {
			numTiles+=14;
		}
	
		if ((setNumber&define.NO_GREEN_TILES)>0) {
			numTiles+=14;
		} 
	
		if ((setNumber&define.NO_YELLOW_TILES)>0) {
			numTiles+=14;
		}

		TileDesc = new String[define.MAX_TILES];
	   TileNames = new int[define.MAX_TILES];
	
		if ((setNumber&define.NO_BLUE_TILES)>0) {
			if (tilesToUse.charAt(0)=='Y') { TileDesc[numCurrentTiles] = "GGRRYY"; TileNames[numCurrentTiles++]=1; }
			if (tilesToUse.charAt(1)=='Y') { TileDesc[numCurrentTiles] = "GGYYRR"; TileNames[numCurrentTiles++]=2; }
			if (tilesToUse.charAt(2)=='Y') { TileDesc[numCurrentTiles] = "GGYRRY"; TileNames[numCurrentTiles++]=3; }
			if (tilesToUse.charAt(3)=='Y') { TileDesc[numCurrentTiles] = "RRGYYG"; TileNames[numCurrentTiles++]=4; }
			if (tilesToUse.charAt(4)=='Y') { TileDesc[numCurrentTiles] = "GGRYYR"; TileNames[numCurrentTiles++]=5; }
			if (tilesToUse.charAt(5)=='Y') { TileDesc[numCurrentTiles] = "YGRYRG"; TileNames[numCurrentTiles++]=6; }
			if (tilesToUse.charAt(6)=='Y') { TileDesc[numCurrentTiles] = "GRYGYR"; TileNames[numCurrentTiles++]=7; }
			if (tilesToUse.charAt(7)=='Y') { TileDesc[numCurrentTiles] = "RGYRYG"; TileNames[numCurrentTiles++]=8; }
			if (tilesToUse.charAt(8)=='Y') { TileDesc[numCurrentTiles] = "YYRGRG"; TileNames[numCurrentTiles++]=9; }
			if (tilesToUse.charAt(9)=='Y') { TileDesc[numCurrentTiles] = "YYGRGR"; TileNames[numCurrentTiles++]=10; }
			if (tilesToUse.charAt(10)=='Y') { TileDesc[numCurrentTiles] = "GGRYRY"; TileNames[numCurrentTiles++]=11; }
			if (tilesToUse.charAt(11)=='Y') { TileDesc[numCurrentTiles] = "GGYRYR"; TileNames[numCurrentTiles++]=12; }
			if (tilesToUse.charAt(12)=='Y') { TileDesc[numCurrentTiles] = "RRGYGY"; TileNames[numCurrentTiles++]=13; }
			if (tilesToUse.charAt(13)=='Y') { TileDesc[numCurrentTiles] = "RRYGYG"; TileNames[numCurrentTiles++]=14; }
		}

		if ((setNumber&define.NO_RED_TILES)>0) {
			if (tilesToUse.charAt(14)=='Y') { TileDesc[numCurrentTiles] = "BBYYGG"; TileNames[numCurrentTiles++]=15; }
			if (tilesToUse.charAt(15)=='Y') { TileDesc[numCurrentTiles] = "BBGGYY"; TileNames[numCurrentTiles++]=16; }
			if (tilesToUse.charAt(16)=='Y') { TileDesc[numCurrentTiles] = "BBYGGY"; TileNames[numCurrentTiles++]=17; }
			if (tilesToUse.charAt(17)=='Y') { TileDesc[numCurrentTiles] = "BBGYYG"; TileNames[numCurrentTiles++]=18; }
			if (tilesToUse.charAt(18)=='Y') { TileDesc[numCurrentTiles] = "GGBYYB"; TileNames[numCurrentTiles++]=19; }
			if (tilesToUse.charAt(19)=='Y') { TileDesc[numCurrentTiles] = "YBGYGB"; TileNames[numCurrentTiles++]=20; }
			if (tilesToUse.charAt(20)=='Y') { TileDesc[numCurrentTiles] = "GBYGYB"; TileNames[numCurrentTiles++]=21; }
			if (tilesToUse.charAt(21)=='Y') { TileDesc[numCurrentTiles] = "BGYBYG"; TileNames[numCurrentTiles++]=22; }
			if (tilesToUse.charAt(22)=='Y') { TileDesc[numCurrentTiles] = "YYBGBG"; TileNames[numCurrentTiles++]=23; }
			if (tilesToUse.charAt(23)=='Y') { TileDesc[numCurrentTiles] = "YYGBGB"; TileNames[numCurrentTiles++]=24; }
			if (tilesToUse.charAt(24)=='Y') { TileDesc[numCurrentTiles] = "GGBYBY"; TileNames[numCurrentTiles++]=25; }
			if (tilesToUse.charAt(25)=='Y') { TileDesc[numCurrentTiles] = "GGYBYB"; TileNames[numCurrentTiles++]=26; }
			if (tilesToUse.charAt(26)=='Y') { TileDesc[numCurrentTiles] = "BBGYGY"; TileNames[numCurrentTiles++]=27; }
			if (tilesToUse.charAt(27)=='Y') { TileDesc[numCurrentTiles] = "BBYGYG"; TileNames[numCurrentTiles++]=28; }
		}

		if ((setNumber&define.NO_GREEN_TILES)>0) {
			if (tilesToUse.charAt(28)=='Y') { TileDesc[numCurrentTiles] = "BBYYRR"; TileNames[numCurrentTiles++]=29; }
			if (tilesToUse.charAt(29)=='Y') { TileDesc[numCurrentTiles] = "BBRRYY"; TileNames[numCurrentTiles++]=30; }
			if (tilesToUse.charAt(30)=='Y') { TileDesc[numCurrentTiles] = "BBYRRY"; TileNames[numCurrentTiles++]=31; }
			if (tilesToUse.charAt(31)=='Y') { TileDesc[numCurrentTiles] = "BBRYYR"; TileNames[numCurrentTiles++]=32; }
			if (tilesToUse.charAt(32)=='Y') { TileDesc[numCurrentTiles] = "RRBYYB"; TileNames[numCurrentTiles++]=33; }
			if (tilesToUse.charAt(33)=='Y') { TileDesc[numCurrentTiles] = "YBRYRB"; TileNames[numCurrentTiles++]=34; }
			if (tilesToUse.charAt(34)=='Y') { TileDesc[numCurrentTiles] = "RBYRYB"; TileNames[numCurrentTiles++]=35; }
			if (tilesToUse.charAt(35)=='Y') { TileDesc[numCurrentTiles] = "BRYBYR"; TileNames[numCurrentTiles++]=36; }
			if (tilesToUse.charAt(36)=='Y') { TileDesc[numCurrentTiles] = "YYBRBR"; TileNames[numCurrentTiles++]=37; }
			if (tilesToUse.charAt(37)=='Y') { TileDesc[numCurrentTiles] = "YYRBRB"; TileNames[numCurrentTiles++]=38; }
			if (tilesToUse.charAt(38)=='Y') { TileDesc[numCurrentTiles] = "RRBYBY"; TileNames[numCurrentTiles++]=39; }
			if (tilesToUse.charAt(39)=='Y') { TileDesc[numCurrentTiles] = "RRYBYB"; TileNames[numCurrentTiles++]=40; }
			if (tilesToUse.charAt(40)=='Y') { TileDesc[numCurrentTiles] = "BBRYRY"; TileNames[numCurrentTiles++]=41; }
			if (tilesToUse.charAt(41)=='Y') { TileDesc[numCurrentTiles] = "BBYRYR"; TileNames[numCurrentTiles++]=42; }
		} 

		if ((setNumber&define.NO_YELLOW_TILES)>0) {
			if (tilesToUse.charAt(42)=='Y') { TileDesc[numCurrentTiles] = "BBGGRR"; TileNames[numCurrentTiles++]=43; }
			if (tilesToUse.charAt(43)=='Y') { TileDesc[numCurrentTiles] = "BBRRGG"; TileNames[numCurrentTiles++]=44; }
			if (tilesToUse.charAt(44)=='Y') { TileDesc[numCurrentTiles] = "BBGRRG"; TileNames[numCurrentTiles++]=45; }
			if (tilesToUse.charAt(45)=='Y') { TileDesc[numCurrentTiles] = "BBRGGR"; TileNames[numCurrentTiles++]=46; }
			if (tilesToUse.charAt(46)=='Y') { TileDesc[numCurrentTiles] = "GGBRRB"; TileNames[numCurrentTiles++]=47; }
			if (tilesToUse.charAt(47)=='Y') { TileDesc[numCurrentTiles] = "GBRGRB"; TileNames[numCurrentTiles++]=48; }
			if (tilesToUse.charAt(48)=='Y') { TileDesc[numCurrentTiles] = "RBGRGB"; TileNames[numCurrentTiles++]=49; }
			if (tilesToUse.charAt(49)=='Y') { TileDesc[numCurrentTiles] = "BGRBRG"; TileNames[numCurrentTiles++]=50; }
			if (tilesToUse.charAt(50)=='Y') { TileDesc[numCurrentTiles] = "GGBRBR"; TileNames[numCurrentTiles++]=51; }
			if (tilesToUse.charAt(51)=='Y') { TileDesc[numCurrentTiles] = "GGRBRB"; TileNames[numCurrentTiles++]=52; }
			if (tilesToUse.charAt(52)=='Y') { TileDesc[numCurrentTiles] = "RRBGBG"; TileNames[numCurrentTiles++]=53; }
			if (tilesToUse.charAt(53)=='Y') { TileDesc[numCurrentTiles] = "RRGBGB"; TileNames[numCurrentTiles++]=54; }
			if (tilesToUse.charAt(54)=='Y') { TileDesc[numCurrentTiles] = "BBRGRG"; TileNames[numCurrentTiles++]=55; }
			if (tilesToUse.charAt(55)=='Y') { TileDesc[numCurrentTiles] = "BBGRGR"; TileNames[numCurrentTiles++]=56; }
		}
	
		numTiles = numCurrentTiles;

	}

	// Displays a tile to the screen
	public void displayTile(int tileNumber) {
		System.out.println(tileNumber+" "+numTiles);
		if (tileNumber < numTiles) System.out.println(TileDesc[tileNumber]);
	}

}
